// 쐬 : 2006-2008 U
// WGL̃bp[NX
// ƁȂ̍\

using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Drawing;
using System.Collections.Generic;
using System.ComponentModel;

namespace GLSharp
{

#pragma warning disable 1591


    #region class PixelFormatDescriptor

    [StructLayout( LayoutKind.Sequential ),
    TypeConverter( typeof( PFDTypeConverter ) )]
    public class PixelFormatDescriptor : ICloneable
    {
        //40byte total
        private short size = 40;
        private short version = 1;
        private PfdPixelFormat flags = PfdPixelFormat.DRAW_TO_WINDOW | PfdPixelFormat.SUPPORT_OPENGL| PfdPixelFormat.DOUBLEBUFFER;
        private PfdPixelType pixelType = PfdPixelType.RGBA;
        private byte colorBits = 32;
        private byte redBits;
        private byte redShift;
        private byte greenBits;
        private byte greenShift;
        private byte blueBits;
        private byte blueShift;
        private byte alphaBits = 8;
        private byte alphaShift;
        private byte accumBits = 0;
        private byte accumRedBits;
        private byte accumGreenBits;
        private byte accumBlueBits;
        private byte accumAlphaBits;
        private byte depthBits = 16;
        private byte stencilBits = 0;
        private byte auxBuffers;
        private PfdLayerType layerType = PfdLayerType.MAIN_PLANE;
        private byte reserved;
        private int layerMask;
        private int visibleMask;
        private int damageMask;


        #region Properties

        [Browsable( false )]
        public short Size
        {
            get { return size; }
        }

        [Browsable( false )]
        public short Version
        {
            get { return version; }
        }

        [Browsable( false ), DefaultValue( PfdPixelFormat.DRAW_TO_WINDOW | PfdPixelFormat.SUPPORT_OPENGL | PfdPixelFormat.DOUBLEBUFFER ),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden )]
        public PfdPixelFormat Flags
        {
            get { return flags; }
            set { flags = value; }
        }

        public PfdPixelType PixelType
        {
            get { return pixelType; }
            set { pixelType = value; }
        }

        public byte ColorBits
        {
            get { return colorBits; }
            set { colorBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden )]
        public byte RedBits
        {
            get { return redBits; }
            set { redBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte RedShift
        {
            get { return redShift; }
            set { redShift = value; }
        }


        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte GreenBits
        {
            get { return greenBits; }
            set { greenBits = value; }
        }


        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte GreenShift
        {
            get { return greenShift; }
            set { greenShift = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte BlueBits
        {
            get { return blueBits; }
            set { blueBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte BlueShift
        {
            get { return blueShift; }
            set { blueShift = value; }
        }

        public byte AlphaBits
        {
            get { return alphaBits; }
            set { alphaBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte AlphaShift
        {
            get { return alphaShift; }
            set { alphaShift = value; }
        }

        public byte AccumBits
        {
            get { return accumBits; }
            set { accumBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte AccumRedBits
        {
            get { return accumRedBits; }
            set { accumRedBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte AccumGreenBits
        {
            get { return accumGreenBits; }
            set { accumGreenBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte AccumBlueBits
        {
            get { return accumBlueBits; }
            set { accumBlueBits = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public byte AccumAlphaBits
        {
            get { return accumAlphaBits; }
            set { accumAlphaBits = value; }
        }

        public byte DepthBits
        {
            get { return depthBits; }
            set { depthBits = value; }
        }

        public byte StencilBits
        {
            get { return stencilBits; }
            set { stencilBits = value; }
        }

        public byte AuxBuffers
        {
            get { return auxBuffers; }
            set { auxBuffers = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public PfdLayerType LayerType
        {
            get { return layerType; }
            set { layerType = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public int LayerMask
        {
            get { return layerMask; }
            set { layerMask = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public int VisibleMask
        {
            get { return visibleMask; }
            set { visibleMask = value; }
        }

        [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
        public int DamageMask
        {
            get { return damageMask; }
            set { damageMask = value; }
        }


        public bool DoubleBuffer
        {
            get { return (this.flags & PfdPixelFormat.DOUBLEBUFFER) == PfdPixelFormat.DOUBLEBUFFER; }
            set
            {
                if( value )
                {
                    this.flags |= PfdPixelFormat.DOUBLEBUFFER;
                }
                else
                {
                    this.flags &= ~PfdPixelFormat.DOUBLEBUFFER; 
                }
            }
        }

        #endregion Properties


        #region ICloneable o

        public object Clone()
        {
            return this.MemberwiseClone();
        }

        #endregion


        #region ToString

        /// <summary>
        /// ̃CX^X\擾B
        /// </summary>
        /// <returns>̃CX^X\</returns>
        public override string ToString()
        {
            return this.ToString( false );
        }

        /// <summary>
        /// ̃CX^X\擾B
        /// </summary>
        /// <param name="breakLine">ɉs܂߂ꍇtrueAłȂfalseB</param>
        /// <returns>̃CX^X\</returns>
        public string ToString( bool breakLine )
        {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append( "Version = " );
            sb.Append( this.version.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "Flags = " );
            sb.Append( this.flags.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( "," );
            sb.Append( "PixelType = " );
            sb.Append( this.pixelType.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "ColorBits = " );
            sb.Append( this.colorBits.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "AlphaBits = " );
            sb.Append( this.alphaBits.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "DeptBits = " );
            sb.Append( this.depthBits.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "AccumBits = " );
            sb.Append( this.accumBits.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "StencilBits = " );
            sb.Append( this.stencilBits.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "LayerType = " );
            sb.Append( this.layerType.ToString() );

            if( breakLine )
                sb.Append( Environment.NewLine );
            else
                sb.Append( ", " );
            sb.Append( "AuxBuffers = " );
            sb.Append( this.auxBuffers.ToString() );

            return sb.ToString();
        }
 
	    #endregion ToString


        #region TryParse

        internal static bool TryParse( string value, out PixelFormatDescriptor pfd )
        {
            string[] words = value.Split( new char[] { ',', ' ', '=', '\r', '\n' }, StringSplitOptions.RemoveEmptyEntries );
            bool parseFailed = false;
            int numValidValues = 0;
            PixelFormatDescriptor pfdTmp = new PixelFormatDescriptor();

            for( int nWord = 0; nWord < words.Length; nWord++ )
            {
                if( words[nWord] == "Flags" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.Flags = (PfdPixelFormat)Enum.Parse( typeof( PfdPixelFormat ), words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "PixelType" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.PixelType = (PfdPixelType)Enum.Parse( typeof( PfdPixelType ), words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "ColorBits" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.ColorBits = byte.Parse( words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "AlphaBits" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.AlphaBits = byte.Parse( words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "DeptBits" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.AlphaBits = byte.Parse( words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "AccumBits" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.AlphaBits = byte.Parse( words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "LayerType" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.LayerType = (PfdLayerType)Enum.Parse( typeof( PfdLayerType ), words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else if( words[nWord] == "AuxBuffers" )
                {
                    nWord++;
                    if( parseFailed = (nWord < words.Length) )
                    {
                        try
                        {
                            pfdTmp.AuxBuffers = byte.Parse( words[nWord] );
                            numValidValues++;
                        }
                        catch { }
                    }
                }
                else
                {
                    parseFailed = true;
                }

                if( parseFailed ) break;
            }

            if( parseFailed || numValidValues <= 0 )
            {
                pfd = null;
                return false;

            }
            else
            {
                pfd = pfdTmp;
                return true;
            }
        }

        #endregion TryParse

    }


    #region PFDTypeConverter (fUCip)

    /// <summary>
    /// (PixelFormatAttributesfUCĩvpeBuEUŎgpł悤ɂ邽߂̃NX)
    /// </summary>
    internal class PFDTypeConverter : System.ComponentModel.ExpandableObjectConverter
    {
        public override bool CanConvertFrom( ITypeDescriptorContext context, Type sourceType )
        {
            return sourceType == typeof( string );
        }

        public override bool CanConvertTo( ITypeDescriptorContext context, Type destinationType )
        {
            return destinationType == typeof( PixelFormatDescriptor );
        }

        public override object ConvertFrom( ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value )
        {
            if( value is string )
            {
                PixelFormatDescriptor pfd;
                string srtValue = (string)value;
                bool valid = PixelFormatDescriptor.TryParse( srtValue, out pfd );

                if( !valid ) throw new ArgumentException( "Can not convert from : " + srtValue );

                return pfd;
            }

            return base.ConvertFrom( context, culture, value );
        }

        public override object ConvertTo( ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value, Type destinationType )
        {
            if( destinationType == typeof( string ) && value is PixelFormatDescriptor )
            {
                PixelFormatDescriptor pfd = (PixelFormatDescriptor)value;
                return pfd.ToString();
            }

            return base.ConvertTo( context, culture, value, destinationType );
        }
    }

    #endregion PFDTypeConverter (fUCip)


    #region enum PfdPixelFormat

    /* PIXELFORMATDESCRIPTOR flags */
    /// <summary>
    /// Pixel format flags for PixelFormatDescripter.PixelFormat
    /// </summary>
    [Flags]
    public enum PfdPixelFormat : uint
    {
        DOUBLEBUFFER = 0x00000001,
        STEREO = 0x00000002,
        DRAW_TO_WINDOW = 0x00000004,
        DRAW_TO_BITMAP = 0x00000008,
        SUPPORT_GDI = 0x00000010,
        SUPPORT_OPENGL = 0x00000020,
        GENERIC_FORMAT = 0x00000040,
        NEED_PALETTE = 0x00000080,
        NEED_SYSTEM_PALETTE = 0x00000100,
        SWAP_EXCHANGE = 0x00000200,
        SWAP_COPY = 0x00000400,
        SWAP_LAYER_BUFFERS = 0x00000800,
        GENERIC_ACCELERATED = 0x00001000,
        SUPPORT_DIRECTDRAW = 0x00002000,

        /* PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only */
        PFD_DEPTH_DONTCARE = 0x20000000,
        PFD_DOUBLEBUFFER_DONTCARE = 0x40000000,
        PFD_STEREO_DONTCARE = 0x80000000,
    }

    #endregion enum PfdPixelFormat


    #region enum PfdPixelType

    /* pixel types */
    /// <summary>
    /// Pixel type flags for PixelFormatDescripter.PixelType
    /// </summary>
    [Flags]
    public enum PfdPixelType : byte
    {
        RGBA = 0,
        COLORINDEX = 1
    }

    #endregion enum PfdPixelType


    #region enum PfdLayerType

    /* layer types */
    /// <summary>
    /// Layer Type flags for PixelFormatDescripter.LayerType
    /// </summary>
    [Flags]
    public enum PfdLayerType : byte
    {
        MAIN_PLANE = 0,
        OVERLAY_PLANE = 1,
        UNDERLAY_PLANE = 0xff // (-1)
    }

    #endregion enum PfdLayerType


    #endregion class PixelFormatDescriptor


    #region class LayerPlaneDescriptor

    /// <summary>
    /// Describes the pixel format of a drawing surface.
    /// </summary>
    [StructLayout( LayoutKind.Sequential )]
    public class LayerPlaneDescriptor
    {
        public static short Size = (short)Marshal.SizeOf( typeof( LayerPlaneDescriptor ) );
        public short Version;
        public int Flags;
        public byte PixelType;
        public byte ColorBits;
        public byte RedBits;
        public byte RedShift;
        public byte GreenBits;
        public byte GreenShift;
        public byte BlueBits;
        public byte BlueShift;
        public byte AlphaBits;
        public byte AlphaShift;
        public byte AccumBits;
        public byte AccumRedBits;
        public byte AccumGreenBits;
        public byte AccumBlueBits;
        public byte AccumAlphaBits;
        public byte DepthBits;
        public byte StencilBits;
        public byte AuxBuffers;
        public byte LayerPlane;
        public byte Reserved;
        public int crTransparent;
    }

    #endregion


    #region struct CharSize

    [StructLayout( LayoutKind.Sequential )]
    public struct CharSize
    {
        public long cx;
        public long cy;
    }

    #endregion struct CharSize


    #region struct GlyphMetricsFloat

    [StructLayout( LayoutKind.Sequential )]
    public struct GlyphMetricsFloat
    {
        /// <summary>
        /// OtSɈ͂ލŏ̋`̕B
        /// </summary>
        public float blackBoxX;
        /// <summary>
        /// OtSɈ͂ލŏ̋`̍B
        /// </summary>
        public float blackBoxY;
        /// <summary>
        /// OtSɈ͂ލŏ̋`̍p̍WB
        /// </summary>
        public PointFloat glyphOrigin;
        /// <summary>
        /// ݂̕Ž_玟̕Ž_܂ł̐B
        /// </summary>
        public float cellIncX;
        /// <summary>
        /// ݂̕Ž_玟̕Ž_܂ł̐B
        /// </summary>
        public float cellIncY;
        // 24 bytes total
    }

    #endregion struct GlyphMetricsFloat


    #region struct PointFloat

    [StructLayout( LayoutKind.Sequential )]
    public struct PointFloat
    {
        public float x;
        public float y;
        // 8 bytes total
    }


    #endregion PointFloat


    #region enum OutlineFontFormat

    [Flags]
    public enum OutlineFontFormat : int
    {
        LINES = 0,
        POLYGONS = 1
    }

    #endregion enum OutlineFontFormat



    public static partial class win32
    {

        #region user32.dll Functions
        //#####################
        // user32.dll Functions

        /// <summary>
        /// return device context of the window
        /// </summary>
        /// <param name="hwnd">Handle to window</param>
        /// <returns>Handle to device context of the window</returns>
        [DllImport( "user32", EntryPoint = "GetDC", SetLastError = true ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern IntPtr GetDC( IntPtr hwnd );

        //[DllImport( "user32", EntryPoint = "ReleaseDC" ), System.Security.SuppressUnmanagedCodeSecurity]
        //public static extern int ReleaseDC( IntPtr hwnd, IntPtr dc );


        #endregion user32.dll Functions
        

        #region kernel32.dll Functions

        [DllImport( "Kernel32" )]
        public static extern IntPtr LoadLibrary( String funcname );
        
        [DllImport( "Kernel32.dll" )]
        public static extern int FreeLibrary( IntPtr handle );

        #endregion kernel32.dll Functions


        #region gdi32.dll Functions


        [DllImport( "gdi32.dll", EntryPoint = "SelectObject" )]
        public static extern IntPtr SelectObject( IntPtr hdc, IntPtr hObj );

        [DllImport( "gdi32.dll", EntryPoint = "GetGlyphOutlineW", CharSet = CharSet.Unicode )]
        public static extern uint GetGlyphOutline( IntPtr hdc,
                                            uint uChar,
                                            GetGlyphOutlineFormat format,
                                            out Glyphmetrics lpgm,
                                            uint cbBuffer,
                                            IntPtr lpvBuffer,
                                            ref MAT2 lpmat2
                                          );

        [DllImport( "gdi32.dll", CharSet=CharSet.Unicode )]
        public static extern bool GetCharWidth32( IntPtr hdc, char firstChar, char lastChar, [Out] int[] width );


        /// <summary>
        /// (gdi) Retrieves an index for a pixel format closest to what is passed
        /// </summary>
        /// <param name="hdc">Device context</param>
        /// <param name="p_pfd">Pixel Format Descriptor struct</param>
        /// <returns></returns>
        [DllImport( "gdi32", EntryPoint = "ChoosePixelFormat" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern int ChoosePixelFormat( IntPtr hdc, PixelFormatDescriptor p_pfd );

        /// <summary>
        /// (gdi) Sets the pixel format for the device context to the format specified by the index
        /// </summary>
        /// <param name="hdc">Device Context</param>
        /// <param name="iPixelFormat">Index to a pixel format returned ChoosePixelFormat</param>
        /// <param name="p_pfd">Pixel Format Descriptor</param>
        /// <returns></returns>
        [DllImport( "gdi32", EntryPoint = "SetPixelFormat" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool SetPixelFormat( IntPtr hdc, int iPixelFormat, PixelFormatDescriptor p_pfd );

        /// <summary>
        /// (gdi)
        /// </summary>
        /// <param name="deviceContext"></param>
        /// <param name="pixel"></param>
        /// <param name="pfdSize"></param>
        /// <param name="pixelFormat"></param>
        /// <returns></returns>
        [DllImport( "gdi32", EntryPoint = "DescribePixelFormat" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern int DescribePixelFormat( IntPtr deviceContext, int pixel, int pfdSize, PixelFormatDescriptor pixelFormat );

        #endregion gdi32.dll Functions


    }



    public static partial class wgl
    {
        public const string GL_DLL = "opengl32.dll";


        #region wgl Functions


        /// <summary>
        /// Creates a rendering context for the Device context.
        /// </summary>
        /// <param name="hdc">Device Context</param>
        /// <returns>Handle to the rendering context</returns>
        [DllImport( GL_DLL, EntryPoint = "wglCreateContext", SetLastError = true ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern IntPtr CreateContext( IntPtr hdc );

        /// <summary>
        /// Sets the current rendering context
        /// </summary>
        /// <param name="hdc">Device Context</param>
        /// <param name="hrc">Rendering Context</param>
        /// <returns></returns>
        [DllImport( GL_DLL, EntryPoint = "wglMakeCurrent", SetLastError = true ), System.Security.SuppressUnmanagedCodeSecurity]
        //[DllImport( GL_DLL, EntryPoint = "wglMakeCurrent" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern int MakeCurrent( IntPtr hdc, IntPtr hrc );

        /// <summary>
        /// Deletes the rendering context
        /// </summary>
        /// <param name="hrc">Rendering context to delet</param>
        /// <returns></returns>
        [DllImport( GL_DLL, EntryPoint = "wglDeleteContext", SetLastError = true ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern int DeleteContext( IntPtr hrc );

        /// <summary>
        /// Swaps the display buffers in a double buffer context
        /// </summary>
        /// <param name="hdc">Device context</param>
        /// <returns></returns>
        [DllImport( GL_DLL, EntryPoint = "wglSwapBuffers", SetLastError = true ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern uint SwapBuffers( IntPtr hdc );


        [DllImport( GL_DLL, EntryPoint = "wglShareLists" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool ShareLists( IntPtr hrc1, IntPtr hrc2 );

        [DllImport( GL_DLL, EntryPoint = "wglCopyContext" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool CopyContext( IntPtr hrcSource, IntPtr hglrcDestination, int attribMaskk );


        [DllImport( GL_DLL, EntryPoint = "wglGetCurrentDC" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern IntPtr GetCurrentDC();

        [DllImport( GL_DLL, EntryPoint = "wglGetCurrentContext" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern IntPtr GetCurrentContext();

        [DllImport( GL_DLL, EntryPoint = "wglGetProcAddress" ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern IntPtr GetProcAddress( string funcname );



        [DllImport( GL_DLL, EntryPoint = "wglUseFontBitmaps", CharSet = CharSet.Auto ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool UseFontBitmaps( IntPtr hdc, int start, int count, uint listbase );

        [DllImport( GL_DLL, EntryPoint = "wglUseFontOutlines", CharSet = CharSet.Unicode ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool UseFontOutlines(
                                                  IntPtr hdc, int first, int count, uint listBase,
                                                  float deviation, float extrusion, OutlineFontFormat format,
                                                  GlyphMetricsFloat[] glyphMetrics
                                                );

        [DllImport( GL_DLL, EntryPoint = "wglUseFontOutlines", CharSet = CharSet.Unicode ), System.Security.SuppressUnmanagedCodeSecurity]
        public static extern bool UseFontOutlines(
                                                  IntPtr hdc, int first, int count, uint listBase,
                                                  float deviation, float extrusion, OutlineFontFormat format,
                                                  ref GlyphMetricsFloat glyphMetrics
                                                );




        #endregion wgl Functions



        #region SupportsFunction

        public static Type typeOfDelegatesClass = typeof( Delegates );

        public static bool SupportsExtFunction( string functoinName )
        {
            System.Reflection.FieldInfo fi = typeOfDelegatesClass.GetField( functoinName );
            return ( fi == null ) ? false : ( ( fi.GetValue( null ) == null ) ? false : true );
        }

        #endregion SupportsFunction


    } // public class WGL


    #region for GetGrifOutline


    #region public struct TTPOLYGONHEADER

    [StructLayout( LayoutKind.Sequential )]
    public struct TTPOLYGONHEADER
    {
        /// <summary>
        /// obt@̃TCY
        /// </summary>
        public int countBuffer;
        /// <summary>
        /// AEgC̎
        /// </summary>
        public int type;

        /// <summary>
        /// Jn_
        /// </summary>
        [MarshalAs( UnmanagedType.Struct )]
        public POINTFX start;
    }

    #endregion

    #region public struct TTPOLYCURVEHEADER

    [StructLayout( LayoutKind.Sequential )]
    public struct TTPOLYCURVEHEADER
    {
        /// <summary>
        /// Ȑ̎ށi1=܂A2=xWFȐj
        /// </summary>
        public short type;
        /// <summary>
        /// _̐
        /// </summary>
        public short countPFX;
    }

    #endregion

    #region public struct FIXED

    [StructLayout( LayoutKind.Sequential )]
    public struct FIXED
    {
        /// <summary>
        /// ( 0x10000 = 1.0 )
        /// </summary>
        public ushort fract;

        /// <summary>
        /// 
        /// </summary>
        public short value;


        public float ToFloat()
        {
            return (float)this;
        }

        public double ToDouble()
        {
            return (double)this;
        }


        public static implicit operator float( FIXED val )
        {
            float f = (float)val.value;
            if( f < 0 )
                f -= (float)val.fract / (float)0x10000;
            else
                f += (float)val.fract / (float)0x10000;

            return f;
        }

        public static implicit operator double( FIXED val )
        {
            double f = (double)val.value;
            if( f < 0 )
                f -= (double)val.fract / (double)0x10000;
            else
                f += (double)val.fract / (double)0x10000;

            return f;
        }

        public static implicit operator FIXED( float val )
        {
            FIXED f = new FIXED();
            f.value = (short)val;
            if( val < 0 ) val *= -1;
            val -= f.value;
            f.fract = (ushort)(val * 0x10000);
            return f;
        }

        public static implicit operator FIXED( int val )
        {
            FIXED f = new FIXED();
            f.value = (short)val;
            return f;
        }
        public static implicit operator FIXED( short val )
        {
            FIXED f = new FIXED();
            f.value = (short)val;
            return f;
        }
        public static implicit operator FIXED( byte val )
        {
            FIXED f = new FIXED();
            f.value = (short)val;
            return f;
        }

    }

    #endregion

    #region public struct MAT2

    [StructLayout( LayoutKind.Sequential )]
    public struct MAT2
    {
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED eM11;
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED eM12;
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED eM21;
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED eM22;


        public MAT2( float m11, float m12, float m21, float m22 )
        {
            this.eM11 = m11;
            this.eM12 = m12;
            this.eM21 = m21;
            this.eM22 = m22;
        }
    }

    #endregion

    #region public struct POINTFX

    [StructLayout( LayoutKind.Sequential )]
    public struct POINTFX
    {
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED x;
        [MarshalAs( UnmanagedType.Struct )]
        public FIXED y;

        public POINTFX( FIXED x, FIXED y )
        {
            this.x = x;
            this.y = y;
        }

        /// <summary>
        /// float[]{x,y}ɕϊB
        /// </summary>
        /// <returns></returns>
        public float[] ToFloatArray()
        {
            return new float[] { x.ToFloat(), y.ToFloat() };
        }

        public double[] ToDoubleArray()
        {
            return new double[] { x.ToDouble(), y.ToDouble() };
        }
    }

    #endregion

    #region public struct Glyphmetrics

    [StructLayout( LayoutKind.Sequential )]
    public struct Glyphmetrics
    {
        public int blackBoxX;
        public int blackBoxY;
        [MarshalAs( UnmanagedType.Struct )]
        public POINTFX glyphOrigin;
        public short cellIncX;
        public short cellIncY;
    }

    #endregion

    #region public enum GetGlyphOutlineFormat

    public enum GetGlyphOutlineFormat : uint
    {
        /// <summary>
        /// GLYPHMETRICS \̂擾B
        /// ق̃obt@͖B
        /// </summary>
        METRICS = 0,
        /// <summary>
        /// Otrbg}bv擾
        /// </summary>
        BITMAP = 1,
        /// <summary>
        /// X^CŰȐf[^|CglCeBu`Ŏ擾AtHg̃fUCPʂgB
        /// ̒lw肳ĂꍇAlpMatrix p[^Ŏw肳ĂῗB
        /// </summary>
        NATIVE = 2,
        /// <summary>
        /// Ȑf[^A4 XvC`ł͂Ȃ 3 xWFXvCƂĎ擾
        /// </summary>
        BEZIER = 3,

        /// <summary>
        /// 5 K̃O[̃Otrbg}bv擾B
        /// </summary>
        GRAY2_BITMAP = 4,
        /// <summary>
        /// 17 K̃O[̃Otrbg}bv擾
        /// </summary>
        GRAY4_BITMAP = 5,
        /// <summary>
        /// 65 K̃O[̃Otrbg}bv擾
        /// </summary>
        GRAY8_BITMAP = 6,
        /// <summary>
        /// Windows 95AWindows NT 4.0  Windows 2000FOtɑ΂ ABC Ԋu擾B
        /// ̏ꍇAA ̓Ot̋󔒁AB ̓Ot̕AC ̓OtE̋󔒂\B
        /// </summary>
        GLYPH_INDEX = 0x0080,

        /// <summary>
        /// Windows 2000FqeBOsȂAEgCԂB
        /// ̃tO GGO_BEZIER  GGO_NATIVE tOƋɎgꍇɂ@\B
        /// </summary>
        UNHINTED = 0x0100
    }

    #endregion


    #endregion for GetGrifOutline
}
