﻿// 作成 : 2008 一歩二歩散歩
// WGLのエクステンション

using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Drawing;
using System.Collections.Generic;

namespace GLSharp
{
    partial class wgl
    {

        public static string GetExtensionsStringEXT( IntPtr hdc )
        {
            if( Delegates.wglGetExtensionsStringEXT == null ) return "";

            return System.Runtime.InteropServices.Marshal.PtrToStringAnsi( Delegates.wglGetExtensionsStringEXT( hdc ) );
        }

        public static bool SwapIntervalEXT( int interval )
        {
            return Delegates.wglSwapIntervalEXT( (int)interval );
        }

        public static int GetSwapIntervalEXT()
        {
            return Delegates.wglGetSwapIntervalEXT();
        }

        public static bool ChoosePixelFormatARB( IntPtr hdc, int[] attribIList, float[] attribFList, uint maxFormats, int[] formats, out uint numFormats )
        {
            return Delegates.wglChoosePixelFormatARB( hdc, attribIList, attribFList, maxFormats, formats, out numFormats );
        }

        public static bool GetPixelFormatAttribivARB( IntPtr hdc, int iPixelFormat, int iLayerPlane, uint nAttributes, int[] piAttributes, [Out] int[] piValues )
        {
            return Delegates.wglGetPixelFormatAttribivARB( hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues );
        }

        private static class Delegates
        {
            public delegate IntPtr GetExtensionsStringEXT( IntPtr hdc );
            public static GetExtensionsStringEXT wglGetExtensionsStringEXT
                = (GetExtensionsStringEXT)GetDelegateForExtensionMethod( "wglGetExtensionsStringEXT", typeof( GetExtensionsStringEXT ) );

            public delegate bool SwapIntervalEXT( int interval );
            public static SwapIntervalEXT wglSwapIntervalEXT
                 = (SwapIntervalEXT)GetDelegateForExtensionMethod( "wglSwapIntervalEXT", typeof( SwapIntervalEXT ) );

            public delegate int GetSwapIntervalEXT();
            public static GetSwapIntervalEXT wglGetSwapIntervalEXT
                = (GetSwapIntervalEXT)GetDelegateForExtensionMethod( "wglGetSwapIntervalEXT", typeof( GetSwapIntervalEXT ) );

            public delegate bool ChoosePixelFormatARB( IntPtr hdc, int[] attribIList, float[] attribFList, uint maxFormats, int[] formats, out uint numFormats );
            public static ChoosePixelFormatARB wglChoosePixelFormatARB
                = (ChoosePixelFormatARB)GetDelegateForExtensionMethod( "wglChoosePixelFormatARB", typeof( ChoosePixelFormatARB ) );

            public delegate bool GetPixelFormatAttribivARB( IntPtr hdc, int iPixelFormat, int iLayerPlane, uint nAttributes, int[] piAttributes, [Out] int[] piValues );
            public static GetPixelFormatAttribivARB wglGetPixelFormatAttribivARB
                                = (GetPixelFormatAttribivARB)GetDelegateForExtensionMethod( "wglGetPixelFormatAttribivARB", typeof( GetPixelFormatAttribivARB ) );
        }

        #region GetDelegateForExtensionMethod

        private static Delegate GetDelegateForExtensionMethod( string name, Type signature )
        {
            IntPtr ptr = GetProcAddress( name );
            if( ptr == IntPtr.Zero )
            {
                return null;
            }
            else
            {
                return Marshal.GetDelegateForFunctionPointer( ptr, signature );
            }
        }

        #endregion GetDelegateForExtensionMethod

    }

}